---
title: XRInputSource.targetRaySpace
slug: Web/API/XRInputSource/targetRaySpace
tags:
  - API
  - AR
  - Controller
  - Input
  - Mixed
  - Property
  - Ray
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSource
  - XRReferenceSpace
  - XRSpace
  - augmented
  - source
  - space
  - target
---
<p>{{APIRef("WebXR")}}{{securecontext_header}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRInputSource")}} property <code><strong>targetRaySpace</strong></code> returns an {{domxref("XRSpace")}} (typically an {{domxref("XRReferenceSpace")}}) representing the position and orientation of the target ray in the virtual space.</span> Its native origin tracks the position of the origin point of the target ray, and its orientation indicates the orientation of the controller device itself. These values, interpreted in the context of the input source's {{domxref("XRInputSource.targetRayMode", "targetRayMode")}}, can be used both to fully interpret the device as an input source.</p>

<p><strong>&lt;&lt;&lt;--- needs diagram showing targetRaySpace relative to gripSpace and world space ---&gt;&gt;&gt;</strong></p>

<p>To obtain an <code>XRSpace</code> representing the input controller's position and orientation in virtual space, use the {{domxref("XRInputSource.gripSpace", "gripSpace")}} property.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>targetRaySpace</em> = <em>xrInputSource</em>.targetRaySpace;</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("XRSpace")}} object—typically an {{domxref("XRReferenceSpace")}} or {{domxref("XRBoundedReferenceSpace")}}—which represents the position and orientation of the input controller's target ray in virtual space.</p>

<p>The native origin of the returned <code>XRSpace</code> is located at the point from which the target ray is emitted, and the orientation of the space indicates the direction in which the target ray is pointing.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>All input sources—regardless of their {{domxref("XRInputSource.targetRayMode", "targetRayMode")}}—have a valid <code>targetRaySpace</code>. The exact meaning of this space varies, however, depending on the mode:</p>

<ul>
 <li>Every gaze input (<code>targetRayMode</code> value of <code>gaze</code>), shares the same {{domxref("XRSpace")}} object as their target ray space, since the gaze input comes from the viewer's head. This shared space represents the same location as the space returned by the {{domxref("XRSession")}} method {{domxref("XRSession.requestReferenceSpace", "requestReferenceSpace()")}}, but is maintained as a different object to allow for future enhancements to the API.</li>
 <li>The target ray space reported by tracked pointer inputs (<code>targetRayMode</code> of <code>tracked-pointer</code>) is actually based upon the true spatial position and orientation of the input device.</li>
</ul>

<p>To determine the position and orientation of the target ray while rendering a frame, pass it into the {{domxref("XRFrame")}} method {{domxref("XRFrame.getPose", "getPose()")}} method, then use the returned {{domxref("XRPose")}} object's {{domxref("XRPose.transform", "transform")}} to gather the spatial information you need.</p>

<h2 id="Example">Example</h2>

<p>{{page("/en-US/docs/Web/API/XRTargetRayMode", "Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrinputsource-targetrayspace','XRInputSource.targetRaySpace')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRInputSource.targetRaySpace")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li><a href="/en-US/docs/Web/WebXR%20Device%20API/Gamepads">Using gamepads in WebXR applications</a></li>
</ul>
